/*! main.css v2026 | (c) Mark Battistella | markbattistella.com */

:root {
  --colour-red: 349, 82%;
  --colour-yellow: 41, 93%;
  --colour-green: 121, 54%;
  --colour-blue: 203, 70%;
  --colour-purple: 265, 57%;
  --colour-orange: 24, 95%;
  --colour-brown: 24, 49%;
  --colour-pink: 337, 79%;
  --colour-pale: 211, 19%;
  --colour-mono: 0, 0%;
  --size-font: 17px;
  --size-radius: 0.5em;
  --size-header: 4em;
  --size-footer: 7em;
  --font-serif: ui-serif, "Iowan Old Style", "Apple Garamond", Baskerville, "Times New Roman", "Droid Serif", Times, "Source Serif Pro", serif, "Apple Color Emoji", "Segoe UI Emoji", "Segoe UI Symbol";
  --font-sans: ui-sans-serif, -apple-system, BlinkMacSystemFont, "Avenir Next", Avenir, "Segoe UI", "Helvetica Neue", Helvetica, Cantarell, Ubuntu, Roboto, Noto, Arial, sans-serif;
  --font-monospace: ui-monospace, SFMono-Regular, Menlo, Consolas, Monaco, "Liberation Mono", "Lucida Console", monospace;
  color-scheme: only dark;
  accent-color: hsl(var(--colour-pink), 50%)
}

* {
  margin: 0;
  padding: 0;
  box-sizing: border-box
}

::selection {
  --mono: 100%;
  background: hsl(var(--colour-pink), 50%);
  color: hsl(var(--colour-mono), var(--mono));
  text-shadow: none;
  border-width: 0;
  text-decoration: none;
  border-color: transparent;
  border-radius: 0
}

[id] {
  scroll-margin-top: 2rem
}

html {
  scroll-behavior: smooth
}

body {
  --mono: 10%;
  font-family: var(--font-sans);
  background: hsl(var(--colour-mono), var(--mono));
  color: hsl(var(--colour-mono), calc(100 - var(--mono)));
  font-size: var(--size-font);
  line-height: 1.7;
  touch-action: pan-y;
  -webkit-font-smoothing: antialiased
}

a {
  text-decoration: none;
  color: hsl(var(--colour-pink), 50%)
}

a:hover {
  text-decoration: underline
}

button,
input,
optgroup,
select,
textarea {
  color: inherit;
  font: inherit;
  margin: 0
}

button,
input,
select,
textarea {
  font-size: 1em;
  vertical-align: baseline;
  border: 1px solid hsl(var(--colour-mono), 65%);
  min-height: 3em;
  width: 100%;
  padding: .7em;
  line-height: 1em
}

button,
input,
textarea {
  font-weight: 400;
  border-radius: var(--size-radius)
}

form {
  margin: 0 0 1em
}

form div.line {
  margin-bottom: 1em
}

form span.required {
  color: hsl(var(--colour-red), 50%);
  font-weight: 700
}

label {
  font-weight: 700;
  display: block;
  margin-top: 2em;
  cursor: pointer
}

label.no-input input {
  display: none
}

label input,
label textarea {
  margin-top: .5em
}

textarea {
  overflow: auto;
  vertical-align: top;
  resize: vertical;
  min-height: 26em;
  margin-bottom: 2em;
}

#submit-button {
  margin: 2em 0
}

[aria-hidden=true] {
  position: absolute;
  left: -9999px;
  width: 1px;
  height: 1px;
  opacity: 0;
  pointer-events: none
}

.button {
  --colour: var(--colour-pale);
  -webkit-appearance: none;
  -webkit-user-select: none;
  appearance: none;
  user-select: none;
  line-height: 2.75em;
  position: relative;
  display: inline-block;
  vertical-align: bottom;
  overflow: visible;
  padding: 0 1.25em;
  border: 0;
  background: hsl(var(--colour), 50%);
  color: hsl(var(--colour-mono), 100%);
  border-radius: var(--size-radius);
  text-decoration: none !important;
  font-weight: 700;
  transition: transform .1s ease;
  top: 0;
  left: 0
}

.button:not(.full-width)+.button:not(.full-width) {
  margin-left: 1em
}

.button.full-width {
  width: 100%;
  text-align: center
}

.button.full-width+.button.full-width {
  margin-top: 1em
}

.button:hover {
  --colour-lightness: 45%
}

.button:active {
  transform: translate(1px, 2px)
}

.button.white:hover {
  background: hsl(var(--colour-mono), 100%)
}

.button.black:hover {
  background: hsl(var(--colour-mono), 0%)
}

.button[disabled],
.button[disabled]:hover {
  background: hsl(var(--colour-mono), 70%);
  color: hsla(var(--colour-mono), 0%, .5);
  cursor: not-allowed
}

.button svg {
  margin: 0 .5em
}

code,
kbd,
pre,
samp {
  font-family: var(--font-mono);
  font-size: .9rem;
  line-height: 1.6;
  direction: ltr;
  text-align: left
}

code {
  padding: .15em .4em;
  background: hsla(var(--colour-mono), 50%, .1);
  border-radius: var(--size-radius);
  white-space: nowrap
}

pre {
  --mono: 5%;
  overflow-x: auto;
  border-radius: var(--size-radius);
  background: hsl(var(--colour-mono), var(--mono));
  padding: 1.25rem 1.5rem;
  margin: 1.5rem 0
}

pre>code {
  background: 0 0;
  display: block;
  white-space: pre;
  overflow: scroll;
  tab-size: 4;
  margin: 0;
  scrollbar-width: none
}

pre>code::-webkit-scrollbar {
  display: none
}

pre.language-script {
  background: hsl(var(--colour-mono), 90%);
  max-width: 21cm;
  padding: 2em;
  color: hsl(var(--colour-mono), 0%);
  margin-left: auto;
  margin-right: auto
}

pre.language-script code {
  white-space: pre-line;
  overflow: hidden
}

pre code .s-keyword {
  color: #ca186f
}

pre code .s-type {
  color: #5957b9
}

pre code .s-call {
  color: #1a74ca
}

pre code .s-property {
  color: #1c9286
}

pre code .s-number {
  color: #d75d42
}

pre code .s-string {
  color: #c13707
}

pre code .s-comment {
  color: #36a270
}

pre code .s-dotAccess {
  color: #1c9286
}

pre code .s-preprocessing {
  color: #a77800
}

kbd {
  background-color: hsl(var(--colour-mono), 90%);
  border-radius: .25rem;
  box-shadow: -1px 2px 0 1px hsl(var(--colour-mono), 40%);
  cursor: default;
  line-height: 1.5;
  min-width: 1.5em;
  display: inline-block;
  position: relative;
  top: -1px;
  margin: 5px;
  text-align: center;
  font-size: 1.2rem;
  font-weight: 700;
  color: hsl(var(--colour-mono), 30%);
  padding: 0 10px
}

blockquote,
q {
  font-size: 1.3em;
  font-family: var(--font-serif);
  padding: 1rem 3rem;
  margin: 1em auto;
  max-width: 80%;
  color: hsl(var(--colour-mono), 90%)
}

blockquote p,
q p {
  margin: 0
}

cite {
  display: block;
  text-align: right;
  margin-top: 1rem
}

cite:before {
  content: "\2014 "
}

sup[id] {
  padding: 0 .25rem
}

div.header {
  text-align: center;
  margin: 2rem 0
}

div.header h1 {
  justify-content: center;
  line-height: 1.25
}

div.header h2 {
  color: hsl(var(--colour-red), 60%)
}

h1,
h2,
h3,
h4,
h5,
h6 {
  position: relative;
  line-height: 1.1;
  margin: 2rem 0 1rem;
  padding: 0;
  font-weight: 400
}

h1,
h2,
h3 {
  font-family: var(--font-serif)
}

article :where(h1, h2, h3, h4, h5, h6) {
  display: flex;
  align-items: flex-start;
  word-break: break-word;
  hyphens: manual;
  hyphenate-character: '—';
  font-weight: 400
}

article h1,
div.header h1 {
  font-size: clamp(calc(var(--size-font) * 2),
      10vw,
      calc(var(--size-font) * 3))
}

article h1 {
  letter-spacing: -.03em;
  margin-bottom: 2rem
}

article h2 {
  font-size: 1.75rem
}

article h3 {
  font-size: 1.35rem
}

article h4 {
  font-size: 1.1rem;
  font-weight: 700
}

article h5,
article h6 {
  font-size: 1rem;
  font-weight: 700
}

:where(h1, h2, h3) code {
  padding: initial;
  background: 0 0;
  line-height: inherit;
  font-size: inherit;
  border-radius: 0;
  white-space: inherit
}

p {
  margin-bottom: 1.25rem
}

s {
  text-decoration-thickness: 2px;
  text-decoration-color: hsl(var(--colour-red), 40%)
}

ol,
ul {
  margin: 0 0 1.5em;
  padding-inline-start: 2em
}

ul {
  list-style: disc outside
}

ol {
  list-style: decimal outside
}

ol ol,
ul ol {
  list-style-type: lower-alpha
}

ol ol ol,
ul ol ol {
  list-style-type: lower-roman
}

ol.normal,
ul.normal {
  list-style: none;
  margin: 0;
  padding: 0;
  text-indent: 0
}

:is(h1, h2, h3, h4, h5, h6) :is(ul, ol) {
  margin: 0;
  text-indent: 0
}

iframe,
img {
  width: auto;
  height: auto;
  max-width: 100%;
  max-height: 60vh;
  object-fit: contain
}

figure {
  text-align: center;
  margin: 2em 0;
  padding: 0
}

figcaption {
  color: hsl(var(--colour-mono), 50%);
  padding-top: .5em;
  font-size: .9rem;
  line-height: 1;
  text-align: center
}

.medium-zoom-image.medium-zoom-image--opened,
figure iframe,
figure img {
  border-radius: var(--size-radius)
}

svg {
  width: 1.5rem;
  height: 1.5rem;
  fill: hsl(var(--colour-mono), 90%)
}

.video-wrapper {
  position: relative;
  aspect-ratio: var(--aspect-ratio, 16 / 9)
}

.video-wrapper iframe,
.video-wrapper video {
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%
}

.table-wrapper {
  max-width: 100%;
  overflow-x: auto
}

table {
  border-collapse: collapse;
  border: 1px solid hsl(var(--colour-mono), 70%);
  font-size: .95rem;
  margin: 1rem 0 2rem;
  width: 100%
}

td,
th {
  padding: .875rem 1rem;
  margin: -1px -1px 0 0;
  border-width: 0 1px 1px 0;
  border-style: solid;
  border-color: hsl(var(--colour-mono), 70%);
  text-align: left
}

th {
  --mono: 100%;
  background: hsla(var(--colour-mono), var(--mono), .15);
  font-weight: 600;
  font-size: .85rem;
  text-transform: uppercase;
  letter-spacing: .03em
}

td[align=left],
th[align=left] {
  text-align: left
}

td[align=right],
th[align=right] {
  text-align: right
}

hr {
  --mono: 30%;
  position: relative;
  margin: 2em 0;
  display: block;
  height: 0;
  color: transparent;
  border-top: 1px solid hsl(var(--colour-mono), var(--mono))
}

hr.end-divider {
  margin: 3.5em 0
}

.wrapper {
  --wrapper-margin: 3em;
  margin: var(--wrapper-margin) 0;
  min-height: calc(100vh - var(--size-header) - var(--size-footer) - var(--wrapper-margin) - var(--size-footer))
}

.container {
  max-width: 50em;
  margin: 0 auto;
  width: calc(100% - 2.5em)
}

header {
  width: 100%
}

header nav {
  height: var(--size-header);
  display: grid;
  grid-template-columns: min-content min-content;
  align-items: center;
  justify-content: space-between;
  font-weight: 700
}

header nav ul {
  display: grid;
  grid-column: 2;
  column-gap: 2px;
  font-size: .8em
}

header nav a {
  display: inline-block;
  border-radius: var(--size-radius);
  margin: 0;
  padding: .8em 2em;
  color: hsl(var(--colour-mono), 90%)
}

header nav a:hover {
  text-decoration: none
}

header nav li a.selected,
header nav li a:hover {
  background: hsla(var(--colour-mono), 50%, .2)
}

header nav a.logo {
  padding-left: 0;
  padding-right: 0;
  color: hsl(var(--colour-orange), 50%)
}

footer,
footer a {
  --mono: 30%
}

footer {
  max-height: var(--size-footer);
  padding: 1em 0 2em;
  margin-top: var(--size-footer);
  text-align: center;
  background: hsla(var(--colour-mono), var(--mono), .15)
}

footer nav .compliance,
footer nav .copyright {
  font-size: .8em
}

footer nav ul {
  display: grid;
  align-items: center;
  justify-content: center;
  column-gap: 1em
}

footer nav .social {
  padding: .5em 0
}

footer nav ul li a {
  padding-left: .5em;
  padding-right: .5em
}

.component-container {
  --mono: 50%;
  --colour: var(--colour-mono);
  background: hsla(var(--colour), var(--mono), .1);
  border-width: 1px;
  border-style: solid;
  border-color: hsl(var(--colour), 80%);
  border-radius: var(--size-radius);
  padding: 1.5em;
  margin: 2em 0;
  overflow: hidden
}

.component-container .component-title {
  font-size: 1.25rem;
  display: grid;
  grid-template-columns: auto 1fr;
  align-items: center;
  color: hsl(var(--colour), 80%)
}

.component-container .component-title svg {
  margin-right: 1rem;
  fill: hsl(var(--colour), 80%)
}

.component-container .component-body {
  margin-top: 1rem
}

.component-container .component-body p:last-child {
  margin-bottom: 0
}

.component-container:has(a.component-body) {
  padding: 0
}

.component-container a.component-body {
  display: grid;
  padding: 1rem 1.5rem;
  text-decoration: none;
  color: hsl(var(--colour-mono), 100%);
  grid-template-columns: 1fr auto;
  grid-template-rows: auto auto;
  align-items: center;
  column-gap: .75em;
  margin-top: 0
}

.component-container a .component-text {
  grid-column: 1;
  grid-row: 1
}

.component-container a .component-icon {
  width: 2em;
  height: 2em;
  grid-column: 2;
  grid-row: 1/span 2;
  display: flex;
  align-items: center;
  justify-content: center
}

.component-container a.component-body:after {
  content: attr(data-name);
  font-size: .8rem;
  color: hsl(var(--colour-mono), 50%);
  word-break: break-all;
  grid-column: 1;
  grid-row: 2
}

#progress {
  position: fixed;
  bottom: 0;
  left: 0;
  width: 0%;
  height: .5em;
  background: hsl(var(--colour-orange), 50%);
  transition-property: width, bottom;
  transition-duration: .3s, .6s;
  transition-timing-function: ease-out
}

ul.postmeta {
  display: flex;
  font-size: .9em;
  margin-top: 1em
}

ul.postmeta li {
  color: hsl(var(--colour-mono), 80%);
  margin-right: 1rem
}

ul.postmeta li:first-child {
  margin-left: 0
}

ul.postmeta li.external {
  display: inline-flex;
  align-items: center;
  font-size: .8rem;
  padding: .1rem 1rem;
  background: hsla(var(--colour-pale), 50%, .2);
  border-radius: var(--size-radius)
}

ul.postmeta li svg {
  width: 1em;
  margin-right: .5rem
}

aside.postmeta {
  border-top: 1px solid hsl(var(--colour-mono), 30%);
  padding-top: 2em;
  margin-top: 3em
}

aside.postmeta ul {
  font-size: .8em;
  line-height: 1.8
}



.red {
  --colour: var(--colour-red)
}

.yellow {
  --colour: var(--colour-yellow)
}

.green {
  --colour: var(--colour-green)
}

.blue {
  --colour: var(--colour-blue)
}

.purple {
  --colour: var(--colour-purple)
}

.orange {
  --colour: var(--colour-orange)
}

.brown {
  --colour: var(--colour-brown)
}

.pink {
  --colour: var(--colour-pink)
}

.white {
  --colour: var(--colour-mono)
}

.black {
  --colour: var(--colour-mono)
}

@media (max-width:48rem) {
  :root {
    --size-font: 16px
  }
}

@media (max-width:30rem) {
  :root {
    --size-header: 7em;
    --size-font: 14px
  }

  ::placeholder,
  input,
  textarea {
    font-size: 16px
  }

  .container {
    width: calc(100% - 1.5rem)
  }

  header nav {
    display: block
  }

  header nav a {
    width: 100%;
    text-align: center;
    padding: 1rem
  }

  footer {
    max-height: min-content;
    margin-top: calc(var(--size-footer)/ 2)
  }

  footer nav ul.compliance {
    display: block
  }

  footer nav ul.social {
    margin-top: 1rem
  }

  footer nav ul.compliance li {
    padding: .25rem 0
  }

  .searchbox span {
    display: none
  }

  section.post-list {
    grid-template-columns: auto
  }

  section.post-list h2.divider {
    position: relative;
    margin-bottom: 1em
  }

  blockquote,
  q {
    max-width: max-content;
    padding: 1rem;
    text-align: center
  }

  .component-container.support .button {
    width: 100%;
    margin: 1rem 0 0 !important;
    text-align: center
  }
}
